#line 945 "../../src/builtin/snarf.m4"
/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 945
#ifdef HAVE_CONFIG_H
#line 945
# include <config.h>
#line 945
#endif
#line 945
#include <sys/types.h>
#line 945

#line 945
#include "mailfromd.h"
#line 945
#include "prog.h"
#line 945
#include "builtin.h"
#line 945

#line 945

#line 985 "../../src/builtin/snarf.m4"

/* End of snarf.m4 */
#line 1 "msg.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008-2019 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "msg.h"
#include "global.h"

static size_t nmsgs = MAX_MSGS;

static struct mu_cfg_param msg_cfg_param[] = {
	{ "max-open-messages", mu_c_size, &nmsgs, 0, NULL,
	  N_("Maximum number of messages to open simultaneously.") },
	{ NULL }
};

static void *
alloc_msgs()
{
	return mu_calloc(nmsgs, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + nmsgs; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].type == MF_MSG_CURRENT) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 59

#line 59
static int MSGTAB_id;
#line 59 "msg.bi"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		mu_stream_destroy(&mp->mstr);
		mu_stream_destroy(&mp->bstr);
		if (mp->type == MF_MSG_STANDALONE)
			mu_message_destroy(&mp->msg,
					   mu_message_get_owner(mp->msg));
		mu_list_foreach(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int type)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->type = type;
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].type == MF_MSG_CURRENT)
			return i;
	return -1;
}


#line 134


#line 145


#line 156


#line 174


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 179
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 179
	struct mf_message *mp;
#line 179
			
#line 179
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 179
		(
#line 179
	env_throw_bi(env, mfe_range, NULL, _("invalid message descriptor"))
#line 179
)
#line 179
;
#line 179
	mp = mtab + nmsg;
#line 179
		if (!(mp->msg))
#line 179
		(
#line 179
	env_throw_bi(env, mfe_failure, NULL, _("message not open"))
#line 179
)
#line 179

#line 179
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 184
bi_message_close(eval_environ_t env)
#line 184

#line 184

#line 184 "msg.bi"
{
#line 184
	
#line 184

#line 184

#line 184
long  nmsg;
#line 184
        
#line 184
get_numeric_arg(env, 0, &nmsg);
#line 184
        
#line 184

#line 184
        adjust_stack(env, 1);
#line 184

#line 184

#line 184
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 184
		prog_trace(env, "message_close %lu",nmsg);;
#line 184

{
	
#line 186
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 186
	struct mf_message *mp;
#line 186
			
#line 186
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 186
		(
#line 186
	env_throw_bi(env, mfe_range, "message_close", _("invalid message descriptor"))
#line 186
)
#line 186
;
#line 186
	mp = mtab + nmsg;
#line 186
		if (!(mp->msg))
#line 186
		(
#line 186
	env_throw_bi(env, mfe_failure, "message_close", _("message not open"))
#line 186
)
#line 186

#line 186
;
	bi_close_message(mp);
}

#line 189
        env_function_cleanup_flush(env, NULL);
#line 189
	return;
#line 189
}

/* number message_size(number nmsg) */
void
#line 192
bi_message_size(eval_environ_t env)
#line 192

#line 192

#line 192 "msg.bi"
{
#line 192
	
#line 192

#line 192

#line 192
long  nmsg;
#line 192
        
#line 192
get_numeric_arg(env, 0, &nmsg);
#line 192
        
#line 192

#line 192
        adjust_stack(env, 1);
#line 192

#line 192

#line 192
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 192
		prog_trace(env, "message_size %lu",nmsg);;
#line 192

{
	int rc;
	size_t size;
	
#line 196
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 196
	struct mf_message *mp;
#line 196
			
#line 196
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 196
		(
#line 196
	env_throw_bi(env, mfe_range, "message_size", _("invalid message descriptor"))
#line 196
)
#line 196
;
#line 196
	mp = mtab + nmsg;
#line 196
		if (!(mp->msg))
#line 196
		(
#line 196
	env_throw_bi(env, mfe_failure, "message_size", _("message not open"))
#line 196
)
#line 196

#line 196
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 199
		(
#line 199
	env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 199
)
#line 201
;
		if (!(size < LONG_MAX))
#line 202
		(
#line 202
	env_throw_bi(env, mfe_range, "message_size", _("message size out of representable range"))
#line 202
)
#line 204
;
	
#line 205
do {
#line 205
  push(env, (STKVAL)(mft_number)((long)size));
#line 205
  goto endlab;
#line 205
} while (0);
}	
endlab:
#line 207
        env_function_cleanup_flush(env, NULL);
#line 207
	return;
#line 207
}

/* number message_lines(number nmsg) */
void
#line 210
bi_message_lines(eval_environ_t env)
#line 210

#line 210

#line 210 "msg.bi"
{
#line 210
	
#line 210

#line 210

#line 210
long  nmsg;
#line 210
        
#line 210
get_numeric_arg(env, 0, &nmsg);
#line 210
        
#line 210

#line 210
        adjust_stack(env, 1);
#line 210

#line 210

#line 210
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 210
		prog_trace(env, "message_lines %lu",nmsg);;
#line 210

{
	int rc;
	size_t lines;
	
#line 214
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 214
	struct mf_message *mp;
#line 214
			
#line 214
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 214
		(
#line 214
	env_throw_bi(env, mfe_range, "message_lines", _("invalid message descriptor"))
#line 214
)
#line 214
;
#line 214
	mp = mtab + nmsg;
#line 214
		if (!(mp->msg))
#line 214
		(
#line 214
	env_throw_bi(env, mfe_failure, "message_lines", _("message not open"))
#line 214
)
#line 214

#line 214
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 217
		(
#line 217
	env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 217
)
#line 220
;
	
#line 221
do {
#line 221
  push(env, (STKVAL)(mft_number)(lines));
#line 221
  goto endlab;
#line 221
} while (0);
}
endlab:
#line 223
        env_function_cleanup_flush(env, NULL);
#line 223
	return;
#line 223
}

/* number message_body_size(number nmsg) */
void
#line 226
bi_message_body_size(eval_environ_t env)
#line 226

#line 226

#line 226 "msg.bi"
{
#line 226
	
#line 226

#line 226

#line 226
long  nmsg;
#line 226
        
#line 226
get_numeric_arg(env, 0, &nmsg);
#line 226
        
#line 226

#line 226
        adjust_stack(env, 1);
#line 226

#line 226

#line 226
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 226
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 226

{
	int rc;
	size_t size;
	
#line 230
	
#line 230
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 230
	struct mf_message *mp;
#line 230
			
#line 230
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 230
		(
#line 230
	env_throw_bi(env, mfe_range, "message_body_size", _("invalid message descriptor"))
#line 230
)
#line 230
;
#line 230
	mp = mtab + nmsg;
#line 230
		if (!(mp->msg))
#line 230
		(
#line 230
	env_throw_bi(env, mfe_failure, "message_body_size", _("message not open"))
#line 230
)
#line 230

#line 230
;
#line 230
	if (!mp->body) {
#line 230
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 230
			if (!(rc == 0))
#line 230
		(
#line 230
	env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 230
)
#line 230
;
#line 230
	}	  
#line 230
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 233
		(
#line 233
	env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 233
)
#line 235
;
		if (!(size < LONG_MAX))
#line 236
		(
#line 236
	env_throw_bi(env, mfe_range, "message_body_size", _("body size out of representable range"))
#line 236
)
#line 238
;
	
#line 239
do {
#line 239
  push(env, (STKVAL)(mft_number)((long)size));
#line 239
  goto endlab;
#line 239
} while (0);
}
endlab:
#line 241
        env_function_cleanup_flush(env, NULL);
#line 241
	return;
#line 241
}

/* boolean message_body_is_empty(number nmsg) */
void
#line 244
bi_message_body_is_empty(eval_environ_t env)
#line 244

#line 244

#line 244 "msg.bi"
{
#line 244
	
#line 244

#line 244

#line 244
long  nmsg;
#line 244
        
#line 244
get_numeric_arg(env, 0, &nmsg);
#line 244
        
#line 244

#line 244
        adjust_stack(env, 1);
#line 244

#line 244

#line 244
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 244
		prog_trace(env, "message_body_is_empty %lu",nmsg);;
#line 244

{
        int rc, res;
	char c;
	size_t n;
	mu_stream_t input, fstr;
	char *encoding = NULL;

	
#line 252
	
#line 252
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 252
	struct mf_message *mp;
#line 252
			
#line 252
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_range, "message_body_is_empty", _("invalid message descriptor"))
#line 252
)
#line 252
;
#line 252
	mp = mtab + nmsg;
#line 252
		if (!(mp->msg))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_failure, "message_body_is_empty", _("message not open"))
#line 252
)
#line 252

#line 252
;
#line 252
	if (!mp->body) {
#line 252
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 252
			if (!(rc == 0))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_message_get_body: %s",mu_strerror(rc))
#line 252
)
#line 252
;
#line 252
	}	  
#line 252
	if (!mp->hdr) {
#line 252
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 252
			if (!(rc == 0))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_message_get_header: %s",mu_strerror(rc))
#line 252
)
#line 252
;
#line 252
	}	  
#line 252
;
	rc = mu_body_size(mp->body, &n);
		if (!(rc == 0))
#line 254
		(
#line 254
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_body_size: %s",mu_strerror(rc))
#line 254
)
#line 256
;
	if (n == 0)
		
#line 258
do {
#line 258
  push(env, (STKVAL)(mft_number)(1));
#line 258
  goto endlab;
#line 258
} while (0);

	rc = mu_body_get_streamref(mp->body, &input);
		if (!(rc == 0))
#line 261
		(
#line 261
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_body_get_streamref: %s",mu_strerror(rc))
#line 261
)
#line 263
;

	mu_header_aget_value_unfold(mp->hdr,
				    MU_HEADER_CONTENT_TRANSFER_ENCODING,
				    &encoding);
	if (encoding) {
		rc = mu_filter_create(&fstr, input, encoding,
				      MU_FILTER_DECODE,
				      MU_STREAM_READ);
		if (rc) {
			mu_error(_("can't create filter for encoding %s: %s"),
				 encoding, mu_strerror(rc));
			fstr = input;
		} else 
			mu_stream_unref(input);
		free(encoding);
	} else
		fstr = input;
	
	res = 1;
	while (mu_stream_read(fstr, &c, 1, &n) == 0 && n > 0) {
		if (!mu_isspace(c)) {
			res = 0;
			break;
		}
	}
	mu_stream_unref(fstr);
	
#line 290
do {
#line 290
  push(env, (STKVAL)(mft_number)(res));
#line 290
  goto endlab;
#line 290
} while (0);
}
endlab:
#line 292
        env_function_cleanup_flush(env, NULL);
#line 292
	return;
#line 292
}
	 
/* number message_body_lines(number nmsg) */
void
#line 295
bi_message_body_lines(eval_environ_t env)
#line 295

#line 295

#line 295 "msg.bi"
{
#line 295
	
#line 295

#line 295

#line 295
long  nmsg;
#line 295
        
#line 295
get_numeric_arg(env, 0, &nmsg);
#line 295
        
#line 295

#line 295
        adjust_stack(env, 1);
#line 295

#line 295

#line 295
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 295
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 295

{
	int rc;
	size_t lines;
	
#line 299
	
#line 299
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 299
	struct mf_message *mp;
#line 299
			
#line 299
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 299
		(
#line 299
	env_throw_bi(env, mfe_range, "message_body_lines", _("invalid message descriptor"))
#line 299
)
#line 299
;
#line 299
	mp = mtab + nmsg;
#line 299
		if (!(mp->msg))
#line 299
		(
#line 299
	env_throw_bi(env, mfe_failure, "message_body_lines", _("message not open"))
#line 299
)
#line 299

#line 299
;
#line 299
	if (!mp->body) {
#line 299
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 299
			if (!(rc == 0))
#line 299
		(
#line 299
	env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 299
)
#line 299
;
#line 299
	}	  
#line 299
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 302
		(
#line 302
	env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 302
)
#line 305
;
	
#line 306
do {
#line 306
  push(env, (STKVAL)(mft_number)(lines));
#line 306
  goto endlab;
#line 306
} while (0);
}
endlab:
#line 308
        env_function_cleanup_flush(env, NULL);
#line 308
	return;
#line 308
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 314
bi_message_header_size(eval_environ_t env)
#line 314

#line 314

#line 314 "msg.bi"
{
#line 314
	
#line 314

#line 314

#line 314
long  nmsg;
#line 314
        
#line 314
get_numeric_arg(env, 0, &nmsg);
#line 314
        
#line 314

#line 314
        adjust_stack(env, 1);
#line 314

#line 314

#line 314
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 314
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 314

{
	int rc;
	size_t size;
	
#line 318
	
#line 318
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 318
	struct mf_message *mp;
#line 318
			
#line 318
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 318
		(
#line 318
	env_throw_bi(env, mfe_range, "message_header_size", _("invalid message descriptor"))
#line 318
)
#line 318
;
#line 318
	mp = mtab + nmsg;
#line 318
		if (!(mp->msg))
#line 318
		(
#line 318
	env_throw_bi(env, mfe_failure, "message_header_size", _("message not open"))
#line 318
)
#line 318

#line 318
;
#line 318
	if (!mp->hdr) {
#line 318
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 318
			if (!(rc == 0))
#line 318
		(
#line 318
	env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 318
)
#line 318
;
#line 318
	}	  
#line 318
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 321
		(
#line 321
	env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 321
)
#line 323
;
		if (!(size < LONG_MAX))
#line 324
		(
#line 324
	env_throw_bi(env, mfe_range, "message_header_size", _("header size out of representable range"))
#line 324
)
#line 326
;
	
#line 327
do {
#line 327
  push(env, (STKVAL)(mft_number)((long)size));
#line 327
  goto endlab;
#line 327
} while (0);
}
endlab:
#line 329
        env_function_cleanup_flush(env, NULL);
#line 329
	return;
#line 329
}

/* number message_header_lines(number nmsg) */
void
#line 332
bi_message_header_lines(eval_environ_t env)
#line 332

#line 332

#line 332 "msg.bi"
{
#line 332
	
#line 332

#line 332

#line 332
long  nmsg;
#line 332
        
#line 332
get_numeric_arg(env, 0, &nmsg);
#line 332
        
#line 332

#line 332
        adjust_stack(env, 1);
#line 332

#line 332

#line 332
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 332
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 332

{
	int rc;
	size_t lines;
	
#line 336
	
#line 336
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 336
	struct mf_message *mp;
#line 336
			
#line 336
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 336
		(
#line 336
	env_throw_bi(env, mfe_range, "message_header_lines", _("invalid message descriptor"))
#line 336
)
#line 336
;
#line 336
	mp = mtab + nmsg;
#line 336
		if (!(mp->msg))
#line 336
		(
#line 336
	env_throw_bi(env, mfe_failure, "message_header_lines", _("message not open"))
#line 336
)
#line 336

#line 336
;
#line 336
	if (!mp->hdr) {
#line 336
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 336
			if (!(rc == 0))
#line 336
		(
#line 336
	env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 336
)
#line 336
;
#line 336
	}	  
#line 336
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 339
		(
#line 339
	env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 339
)
#line 342
;
	
#line 343
do {
#line 343
  push(env, (STKVAL)(mft_number)(lines));
#line 343
  goto endlab;
#line 343
} while (0);
}
endlab:
#line 345
        env_function_cleanup_flush(env, NULL);
#line 345
	return;
#line 345
}

/* number message_header_count(number nmsg[; string name]) */
void
#line 348
bi_message_header_count(eval_environ_t env)
#line 348

#line 348

#line 348 "msg.bi"
{
#line 348
	
#line 348

#line 348
long __bi_argcnt;
#line 348
long  nmsg;
#line 348
        char *  name;
#line 348
        
#line 348
get_numeric_arg(env, 1, &nmsg);
#line 348
        get_string_arg(env, 2, &name);
#line 348
        
#line 348
get_numeric_arg(env, 0, &__bi_argcnt);
#line 348
        adjust_stack(env, __bi_argcnt + 1);
#line 348

#line 348

#line 348
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 348
		prog_trace(env, "message_header_count %lu %s",nmsg, ((__bi_argcnt > 1) ? name : ""));;

{
	int rc;
	size_t count;
	
#line 353
	
#line 353
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 353
	struct mf_message *mp;
#line 353
			
#line 353
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 353
		(
#line 353
	env_throw_bi(env, mfe_range, "message_header_count", _("invalid message descriptor"))
#line 353
)
#line 353
;
#line 353
	mp = mtab + nmsg;
#line 353
		if (!(mp->msg))
#line 353
		(
#line 353
	env_throw_bi(env, mfe_failure, "message_header_count", _("message not open"))
#line 353
)
#line 353

#line 353
;
#line 353
	if (!mp->hdr) {
#line 353
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 353
			if (!(rc == 0))
#line 353
		(
#line 353
	env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 353
)
#line 353
;
#line 353
	}	  
#line 353
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 356
		(
#line 356
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 356
)
#line 359
;
	
	if ((__bi_argcnt > 1)) {
		size_t n;

		for (n = 1; n <= count; n++) {
			const char *val;
			rc = mu_header_sget_value_n(mp->hdr, name, n, &val);
			if (rc == MU_ERR_NOENT)
				break;
			else if (rc)
				(
#line 370
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 370
);
		}
		count = n - 1;
	}
	
#line 374
do {
#line 374
  push(env, (STKVAL)(mft_number)(count));
#line 374
  goto endlab;
#line 374
} while (0);
}
endlab:
#line 376
        env_function_cleanup_flush(env, NULL);
#line 376
	return;
#line 376
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 379
bi_message_has_header(eval_environ_t env)
#line 379

#line 379

#line 379 "msg.bi"
{
#line 379
	
#line 379

#line 379
long __bi_argcnt;
#line 379
long  nmsg;
#line 379
        char *  header;
#line 379
        long  idx;
#line 379
        
#line 379
get_numeric_arg(env, 1, &nmsg);
#line 379
        get_string_arg(env, 2, &header);
#line 379
        get_numeric_arg(env, 3, &idx);
#line 379
        
#line 379
get_numeric_arg(env, 0, &__bi_argcnt);
#line 379
        adjust_stack(env, __bi_argcnt + 1);
#line 379

#line 379

#line 379
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 379
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 384
	
#line 384
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 384
	struct mf_message *mp;
#line 384
			
#line 384
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 384
		(
#line 384
	env_throw_bi(env, mfe_range, "message_has_header", _("invalid message descriptor"))
#line 384
)
#line 384
;
#line 384
	mp = mtab + nmsg;
#line 384
		if (!(mp->msg))
#line 384
		(
#line 384
	env_throw_bi(env, mfe_failure, "message_has_header", _("message not open"))
#line 384
)
#line 384

#line 384
;
#line 384
	if (!mp->hdr) {
#line 384
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 384
			if (!(rc == 0))
#line 384
		(
#line 384
	env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 384
)
#line 384
;
#line 384
	}	  
#line 384
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 387
do {
#line 387
  push(env, (STKVAL)(mft_number)(rc == 0));
#line 387
  goto endlab;
#line 387
} while (0);
}
endlab:
#line 389
        env_function_cleanup_flush(env, NULL);
#line 389
	return;
#line 389
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 392
bi_message_find_header(eval_environ_t env)
#line 392

#line 392

#line 392 "msg.bi"
{
#line 392
	
#line 392

#line 392
long __bi_argcnt;
#line 392
long  nmsg;
#line 392
        char * MFL_DATASEG header;
#line 392
        long  idx;
#line 392
        
#line 392
get_numeric_arg(env, 1, &nmsg);
#line 392
        get_string_arg(env, 2, &header);
#line 392
        get_numeric_arg(env, 3, &idx);
#line 392
        
#line 392
get_numeric_arg(env, 0, &__bi_argcnt);
#line 392
        adjust_stack(env, __bi_argcnt + 1);
#line 392

#line 392

#line 392
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 392
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 397
	
#line 397
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 397
	struct mf_message *mp;
#line 397
			
#line 397
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 397
		(
#line 397
	env_throw_bi(env, mfe_range, "message_find_header", _("invalid message descriptor"))
#line 397
)
#line 397
;
#line 397
	mp = mtab + nmsg;
#line 397
		if (!(mp->msg))
#line 397
		(
#line 397
	env_throw_bi(env, mfe_failure, "message_find_header", _("message not open"))
#line 397
)
#line 397

#line 397
;
#line 397
	if (!mp->hdr) {
#line 397
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 397
			if (!(rc == 0))
#line 397
		(
#line 397
	env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 397
)
#line 397
;
#line 397
	}	  
#line 397
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
		(
#line 401
	env_throw_bi(env, mfe_not_found, "message_find_header", _("header not found"))
#line 401
);
	else if (rc)
		(
#line 403
	env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc))
#line 403
);
	
#line 404
do {
#line 404
  pushs(env, val);
#line 404
  goto endlab;
#line 404
} while (0);
}
endlab:
#line 406
        env_function_cleanup_flush(env, NULL);
#line 406
	return;
#line 406
}

/* string message_nth_header_name(number msg, number n) */
void
#line 409
bi_message_nth_header_name(eval_environ_t env)
#line 409

#line 409

#line 409 "msg.bi"
{
#line 409
	
#line 409

#line 409

#line 409
long  nmsg;
#line 409
        long  idx;
#line 409
        
#line 409
get_numeric_arg(env, 0, &nmsg);
#line 409
        get_numeric_arg(env, 1, &idx);
#line 409
        
#line 409

#line 409
        adjust_stack(env, 2);
#line 409

#line 409

#line 409
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 409
		prog_trace(env, "message_nth_header_name %lu %lu",nmsg, idx);;
#line 409

{
	int rc;
	const char *val;
	
#line 413
	
#line 413
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 413
	struct mf_message *mp;
#line 413
			
#line 413
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 413
		(
#line 413
	env_throw_bi(env, mfe_range, "message_nth_header_name", _("invalid message descriptor"))
#line 413
)
#line 413
;
#line 413
	mp = mtab + nmsg;
#line 413
		if (!(mp->msg))
#line 413
		(
#line 413
	env_throw_bi(env, mfe_failure, "message_nth_header_name", _("message not open"))
#line 413
)
#line 413

#line 413
;
#line 413
	if (!mp->hdr) {
#line 413
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 413
			if (!(rc == 0))
#line 413
		(
#line 413
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "mu_message_get_header: %s",mu_strerror(rc))
#line 413
)
#line 413
;
#line 413
	}	  
#line 413
;
	
	rc = mu_header_sget_field_name(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 417
	env_throw_bi(env, mfe_range, "message_nth_header_name", "header index out of range")
#line 417
);
	else if (rc)
		(
#line 419
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "%s",mu_strerror(rc))
#line 419
);
	
#line 420
do {
#line 420
  pushs(env, val);
#line 420
  goto endlab;
#line 420
} while (0);
}
endlab:
#line 422
        env_function_cleanup_flush(env, NULL);
#line 422
	return;
#line 422
}

/* string message_nth_header_value(number msg, number n) */
void
#line 425
bi_message_nth_header_value(eval_environ_t env)
#line 425

#line 425

#line 425 "msg.bi"
{
#line 425
	
#line 425

#line 425

#line 425
long  nmsg;
#line 425
        long  idx;
#line 425
        
#line 425
get_numeric_arg(env, 0, &nmsg);
#line 425
        get_numeric_arg(env, 1, &idx);
#line 425
        
#line 425

#line 425
        adjust_stack(env, 2);
#line 425

#line 425

#line 425
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 425
		prog_trace(env, "message_nth_header_value %lu %lu",nmsg, idx);;
#line 425

{
	int rc;
	const char *val;
	
#line 429
	
#line 429
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 429
	struct mf_message *mp;
#line 429
			
#line 429
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 429
		(
#line 429
	env_throw_bi(env, mfe_range, "message_nth_header_value", _("invalid message descriptor"))
#line 429
)
#line 429
;
#line 429
	mp = mtab + nmsg;
#line 429
		if (!(mp->msg))
#line 429
		(
#line 429
	env_throw_bi(env, mfe_failure, "message_nth_header_value", _("message not open"))
#line 429
)
#line 429

#line 429
;
#line 429
	if (!mp->hdr) {
#line 429
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 429
			if (!(rc == 0))
#line 429
		(
#line 429
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "mu_message_get_header: %s",mu_strerror(rc))
#line 429
)
#line 429
;
#line 429
	}	  
#line 429
;
	
	rc = mu_header_sget_field_value(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 433
	env_throw_bi(env, mfe_range, "message_nth_header_value", "header index out of range")
#line 433
);
	else if (rc)
		(
#line 435
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "%s",mu_strerror(rc))
#line 435
);
	
#line 436
do {
#line 436
  pushs(env, val);
#line 436
  goto endlab;
#line 436
} while (0);
}
endlab:
#line 438
        env_function_cleanup_flush(env, NULL);
#line 438
	return;
#line 438
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 444
bi_message_is_multipart(eval_environ_t env)
#line 444

#line 444

#line 444 "msg.bi"
{
#line 444
	
#line 444

#line 444

#line 444
long  nmsg;
#line 444
        
#line 444
get_numeric_arg(env, 0, &nmsg);
#line 444
        
#line 444

#line 444
        adjust_stack(env, 1);
#line 444

#line 444

#line 444
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 444
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 444

{
	int rc, res;
	
#line 447
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 447
	struct mf_message *mp;
#line 447
			
#line 447
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 447
		(
#line 447
	env_throw_bi(env, mfe_range, "message_is_multipart", _("invalid message descriptor"))
#line 447
)
#line 447
;
#line 447
	mp = mtab + nmsg;
#line 447
		if (!(mp->msg))
#line 447
		(
#line 447
	env_throw_bi(env, mfe_failure, "message_is_multipart", _("message not open"))
#line 447
)
#line 447

#line 447
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 450
		(
#line 450
	env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 450
)
#line 453
;
	
#line 454
do {
#line 454
  push(env, (STKVAL)(mft_number)(res));
#line 454
  goto endlab;
#line 454
} while (0);
}
endlab:
#line 456
        env_function_cleanup_flush(env, NULL);
#line 456
	return;
#line 456
}

/* number message_count_parts(number msg) */
void
#line 459
bi_message_count_parts(eval_environ_t env)
#line 459

#line 459

#line 459 "msg.bi"
{
#line 459
	
#line 459

#line 459

#line 459
long  nmsg;
#line 459
        
#line 459
get_numeric_arg(env, 0, &nmsg);
#line 459
        
#line 459

#line 459
        adjust_stack(env, 1);
#line 459

#line 459

#line 459
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 459
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 459

{
	int rc;
	size_t count;
	
#line 463
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 463
	struct mf_message *mp;
#line 463
			
#line 463
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 463
		(
#line 463
	env_throw_bi(env, mfe_range, "message_count_parts", _("invalid message descriptor"))
#line 463
)
#line 463
;
#line 463
	mp = mtab + nmsg;
#line 463
		if (!(mp->msg))
#line 463
		(
#line 463
	env_throw_bi(env, mfe_failure, "message_count_parts", _("message not open"))
#line 463
)
#line 463

#line 463
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 465
		(
#line 465
	env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 465
)
#line 468
;
	
#line 469
do {
#line 469
  push(env, (STKVAL)(mft_number)(count));
#line 469
  goto endlab;
#line 469
} while (0);
}
endlab:
#line 471
        env_function_cleanup_flush(env, NULL);
#line 471
	return;
#line 471
}

/* number message_get_part(number msg, number idx) */
void
#line 474
bi_message_get_part(eval_environ_t env)
#line 474

#line 474

#line 474 "msg.bi"
{
#line 474
	
#line 474

#line 474

#line 474
long  nmsg;
#line 474
        long  idx;
#line 474
        
#line 474
get_numeric_arg(env, 0, &nmsg);
#line 474
        get_numeric_arg(env, 1, &idx);
#line 474
        
#line 474

#line 474
        adjust_stack(env, 2);
#line 474

#line 474

#line 474
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 474
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 474

{
	int rc;
	mu_message_t msg;
	
#line 478
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 478
	struct mf_message *mp;
#line 478
			
#line 478
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 478
		(
#line 478
	env_throw_bi(env, mfe_range, "message_get_part", _("invalid message descriptor"))
#line 478
)
#line 478
;
#line 478
	mp = mtab + nmsg;
#line 478
		if (!(mp->msg))
#line 478
		(
#line 478
	env_throw_bi(env, mfe_failure, "message_get_part", _("message not open"))
#line 478
)
#line 478

#line 478
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 481
		(
#line 481
	env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 481
)
#line 484
;
	rc = bi_message_register(env, mp->msglist, msg, MF_MSG_MAILBOX);
		if (!(rc >= 0))
#line 486
		(
#line 486
	env_throw_bi(env, mfe_failure, "message_get_part", _("no more message slots available"))
#line 486
)
#line 488
;
	
#line 489
do {
#line 489
  push(env, (STKVAL)(mft_number)(rc));
#line 489
  goto endlab;
#line 489
} while (0);
}
endlab:
#line 491
        env_function_cleanup_flush(env, NULL);
#line 491
	return;
#line 491
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 497
bi_message_rewind(eval_environ_t env)
#line 497

#line 497

#line 497 "msg.bi"
{
#line 497
	
#line 497

#line 497

#line 497
long  nmsg;
#line 497
        
#line 497
get_numeric_arg(env, 0, &nmsg);
#line 497
        
#line 497

#line 497
        adjust_stack(env, 1);
#line 497

#line 497

#line 497
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 497
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 497

{
	
#line 499
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 499
	struct mf_message *mp;
#line 499
			
#line 499
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 499
		(
#line 499
	env_throw_bi(env, mfe_range, "message_rewind", _("invalid message descriptor"))
#line 499
)
#line 499
;
#line 499
	mp = mtab + nmsg;
#line 499
		if (!(mp->msg))
#line 499
		(
#line 499
	env_throw_bi(env, mfe_failure, "message_rewind", _("message not open"))
#line 499
)
#line 499

#line 499
;
	mu_stream_destroy(&mp->mstr);
}

#line 502
        env_function_cleanup_flush(env, NULL);
#line 502
	return;
#line 502
}

/* string message_read_line(number nmsg) */
void
#line 505
bi_message_read_line(eval_environ_t env)
#line 505

#line 505

#line 505 "msg.bi"
{
#line 505
	
#line 505

#line 505

#line 505
long  nmsg;
#line 505
        
#line 505
get_numeric_arg(env, 0, &nmsg);
#line 505
        
#line 505

#line 505
        adjust_stack(env, 1);
#line 505

#line 505

#line 505
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 505
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 505

{
	int rc;
	size_t size;
	
#line 509
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 509
	struct mf_message *mp;
#line 509
			
#line 509
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 509
		(
#line 509
	env_throw_bi(env, mfe_range, "message_read_line", _("invalid message descriptor"))
#line 509
)
#line 509
;
#line 509
	mp = mtab + nmsg;
#line 509
		if (!(mp->msg))
#line 509
		(
#line 509
	env_throw_bi(env, mfe_failure, "message_read_line", _("message not open"))
#line 509
)
#line 509

#line 509
;

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 513
		(
#line 513
	env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 513
)
#line 516
;
	}
	rc = mu_stream_getline(mp->mstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 519
		(
#line 519
	env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 519
)
#line 522
;
		if (!(size > 0))
#line 523
		(
#line 523
	env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_getline: %s",_("end of input"))
#line 523
)
#line 526
;
	
#line 527
do {
#line 527
  pushs(env, mp->buf);
#line 527
  goto endlab;
#line 527
} while (0);
}
endlab:
#line 529
        env_function_cleanup_flush(env, NULL);
#line 529
	return;
#line 529
}

/* string message_body_rewind(number nmsg) */
void
#line 532
bi_message_body_rewind(eval_environ_t env)
#line 532

#line 532

#line 532 "msg.bi"
{
#line 532
	
#line 532

#line 532

#line 532
long  nmsg;
#line 532
        
#line 532
get_numeric_arg(env, 0, &nmsg);
#line 532
        
#line 532

#line 532
        adjust_stack(env, 1);
#line 532

#line 532

#line 532
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 532
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 532

{
	
#line 534
	
#line 534
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 534
	struct mf_message *mp;
#line 534
			
#line 534
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 534
		(
#line 534
	env_throw_bi(env, mfe_range, "message_body_rewind", _("invalid message descriptor"))
#line 534
)
#line 534
;
#line 534
	mp = mtab + nmsg;
#line 534
		if (!(mp->msg))
#line 534
		(
#line 534
	env_throw_bi(env, mfe_failure, "message_body_rewind", _("message not open"))
#line 534
)
#line 534

#line 534
;
#line 534
	if (!mp->body) {
#line 534
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 534
			if (!(rc == 0))
#line 534
		(
#line 534
	env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 534
)
#line 534
;
#line 534
	}	  
#line 534
;
	mu_stream_destroy(&mp->bstr);
}

#line 537
        env_function_cleanup_flush(env, NULL);
#line 537
	return;
#line 537
}

/* string message_read_body_line(number msg)  */
void
#line 540
bi_message_read_body_line(eval_environ_t env)
#line 540

#line 540

#line 540 "msg.bi"
{
#line 540
	
#line 540

#line 540

#line 540
long  nmsg;
#line 540
        
#line 540
get_numeric_arg(env, 0, &nmsg);
#line 540
        
#line 540

#line 540
        adjust_stack(env, 1);
#line 540

#line 540

#line 540
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 540
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 540

{
	int rc;
	size_t size;
	
#line 544
	
#line 544
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 544
	struct mf_message *mp;
#line 544
			
#line 544
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 544
		(
#line 544
	env_throw_bi(env, mfe_range, "message_read_body_line", _("invalid message descriptor"))
#line 544
)
#line 544
;
#line 544
	mp = mtab + nmsg;
#line 544
		if (!(mp->msg))
#line 544
		(
#line 544
	env_throw_bi(env, mfe_failure, "message_read_body_line", _("message not open"))
#line 544
)
#line 544

#line 544
;
#line 544
	if (!mp->body) {
#line 544
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 544
			if (!(rc == 0))
#line 544
		(
#line 544
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 544
)
#line 544
;
#line 544
	}	  
#line 544
;
	
	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 548
		(
#line 548
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 548
)
#line 551
;
	}
	rc = mu_stream_getline(mp->bstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 554
		(
#line 554
	env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 554
)
#line 557
;
		if (!(size > 0))
#line 558
		(
#line 558
	env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_getline: %s",_("end of input"))
#line 558
)
#line 561
;
	
#line 562
do {
#line 562
  pushs(env, mp->buf);
#line 562
  goto endlab;
#line 562
} while (0);
}
endlab:
#line 564
        env_function_cleanup_flush(env, NULL);
#line 564
	return;
#line 564
}

/* string message_to_stream(number fd, number msg; string mu_filter_chain) */
void
#line 567
bi_message_to_stream(eval_environ_t env)
#line 567

#line 567

#line 567 "msg.bi"
{
#line 567
	
#line 567

#line 567
long __bi_argcnt;
#line 567
long  fd;
#line 567
        long  nmsg;
#line 567
        char *  fltchain;
#line 567
        
#line 567
get_numeric_arg(env, 1, &fd);
#line 567
        get_numeric_arg(env, 2, &nmsg);
#line 567
        get_string_arg(env, 3, &fltchain);
#line 567
        
#line 567
get_numeric_arg(env, 0, &__bi_argcnt);
#line 567
        adjust_stack(env, __bi_argcnt + 1);
#line 567

#line 567

#line 567
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 567
		prog_trace(env, "message_to_stream %lu %lu %s",fd, nmsg, ((__bi_argcnt > 2) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t dst;
	char *flts = ((__bi_argcnt > 2) ? fltchain : 0);
	
	
#line 575
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 575
	struct mf_message *mp;
#line 575
			
#line 575
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 575
		(
#line 575
	env_throw_bi(env, mfe_range, "message_to_stream", _("invalid message descriptor"))
#line 575
)
#line 575
;
#line 575
	mp = mtab + nmsg;
#line 575
		if (!(mp->msg))
#line 575
		(
#line 575
	env_throw_bi(env, mfe_failure, "message_to_stream", _("message not open"))
#line 575
)
#line 575

#line 575
;
	
	rc = mu_fd_stream_create(&dst, NULL, _bi_io_fd(env, fd, 1),
				 MU_STREAM_WRITE);
		if (!(rc == 0))
#line 579
		(
#line 579
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 579
)
#line 582
;
	mu_stream_ioctl(dst, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 589
		(
#line 589
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 589
)
#line 592
;
		rc = mu_filter_chain_create(&flt, dst, MU_FILTER_ENCODE,
					    MU_STREAM_WRITE,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 597
		(
#line 597
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 597
)
#line 601
;
		mu_stream_unref(dst);
		dst = flt;
	}

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 608
		(
#line 608
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_message_get_stream: %s",mu_strerror(rc))
#line 608
)
#line 611
;
	}
	rc = mu_stream_copy(dst, mp->mstr, 0, NULL);
		if (!(rc == 0))
#line 614
		(
#line 614
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_stream_copy: %s",mu_strerror(rc))
#line 614
)
#line 617
;
	mu_stream_close(dst);
	mu_stream_unref(dst);
}

#line 621
        env_function_cleanup_flush(env, NULL);
#line 621
	return;
#line 621
}

/* number message_from_stream(number fd; string mu_filter_chain) */
void
#line 624
bi_message_from_stream(eval_environ_t env)
#line 624

#line 624

#line 624 "msg.bi"
{
#line 624
	
#line 624

#line 624
long __bi_argcnt;
#line 624
long  fd;
#line 624
        char *  fltchain;
#line 624
        
#line 624
get_numeric_arg(env, 1, &fd);
#line 624
        get_string_arg(env, 2, &fltchain);
#line 624
        
#line 624
get_numeric_arg(env, 0, &__bi_argcnt);
#line 624
        adjust_stack(env, __bi_argcnt + 1);
#line 624

#line 624

#line 624
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 624
		prog_trace(env, "message_from_stream %lu %s",fd, ((__bi_argcnt > 1) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t src;
	char *flts = ((__bi_argcnt > 1) ? fltchain : 0);
	mu_message_t msg;
	
	rc = mu_fd_stream_create(&src, NULL, _bi_io_fd(env, fd, 0),
				 MU_STREAM_READ|MU_STREAM_SEEK);
				    
		if (!(rc == 0))
#line 636
		(
#line 636
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 636
)
#line 639
;
	mu_stream_ioctl(src, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 646
		(
#line 646
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 646
)
#line 649
;
		rc = mu_filter_chain_create(&flt, src, MU_FILTER_ENCODE,
					    MU_STREAM_READ,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 654
		(
#line 654
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 654
)
#line 658
;
		mu_stream_unref(src);
		src = flt;
	}

	msg = _builtin_mu_stream_to_message(src, env, "message_from_stream");

	rc = bi_message_register(env, NULL, msg, MF_MSG_STANDALONE);
	if (rc < 0) {
		mu_message_destroy(&msg, mu_message_get_owner(msg));
		(
#line 668
	env_throw_bi(env, mfe_failure, "message_from_stream", _("no more message slots available"))
#line 668
);
#line 670
	}
	
#line 671
do {
#line 671
  push(env, (STKVAL)(mft_number)(rc));
#line 671
  goto endlab;
#line 671
} while (0);
}
endlab:
#line 673
        env_function_cleanup_flush(env, NULL);
#line 673
	return;
#line 673
}

/* string message_body_to_stream(number fd, number msg; string mu_filter_chain) */
void
#line 676
bi_message_body_to_stream(eval_environ_t env)
#line 676

#line 676

#line 676 "msg.bi"
{
#line 676
	
#line 676

#line 676
long __bi_argcnt;
#line 676
long  fd;
#line 676
        long  nmsg;
#line 676
        char *  fltchain;
#line 676
        
#line 676
get_numeric_arg(env, 1, &fd);
#line 676
        get_numeric_arg(env, 2, &nmsg);
#line 676
        get_string_arg(env, 3, &fltchain);
#line 676
        
#line 676
get_numeric_arg(env, 0, &__bi_argcnt);
#line 676
        adjust_stack(env, __bi_argcnt + 1);
#line 676

#line 676

#line 676
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 676
		prog_trace(env, "message_body_to_stream %lu %lu %s",fd, nmsg, ((__bi_argcnt > 2) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t dst;
	char *flts = ((__bi_argcnt > 2) ? fltchain : 0);
	
	
#line 684
	
#line 684
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 684
	struct mf_message *mp;
#line 684
			
#line 684
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 684
		(
#line 684
	env_throw_bi(env, mfe_range, "message_body_to_stream", _("invalid message descriptor"))
#line 684
)
#line 684
;
#line 684
	mp = mtab + nmsg;
#line 684
		if (!(mp->msg))
#line 684
		(
#line 684
	env_throw_bi(env, mfe_failure, "message_body_to_stream", _("message not open"))
#line 684
)
#line 684

#line 684
;
#line 684
	if (!mp->body) {
#line 684
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 684
			if (!(rc == 0))
#line 684
		(
#line 684
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_message_get_body: %s",mu_strerror(rc))
#line 684
)
#line 684
;
#line 684
	}	  
#line 684
;
	
	rc = mu_fd_stream_create(&dst, NULL, _bi_io_fd(env, fd, 1),
				 MU_STREAM_WRITE);
		if (!(rc == 0))
#line 688
		(
#line 688
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 688
)
#line 691
;
	mu_stream_ioctl(dst, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 698
		(
#line 698
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 698
)
#line 701
;
		rc = mu_filter_chain_create(&flt, dst, MU_FILTER_ENCODE,
					    MU_STREAM_WRITE,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 706
		(
#line 706
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 706
)
#line 710
;
		mu_stream_unref(dst);
		dst = flt;
	}

	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 717
		(
#line 717
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_body_get_stream: %s",mu_strerror(rc))
#line 717
)
#line 720
;
	}
	rc = mu_stream_copy(dst, mp->bstr, 0, NULL);
		if (!(rc == 0))
#line 723
		(
#line 723
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_stream_copy: %s",mu_strerror(rc))
#line 723
)
#line 726
;
	mu_stream_close(dst);
	mu_stream_unref(dst);
}

#line 730
        env_function_cleanup_flush(env, NULL);
#line 730
	return;
#line 730
}

 
#line 945 "../../src/builtin/snarf.m4"

#line 945

#line 945

#line 945
void
#line 945
msg_init_builtin(void)
#line 945
{
#line 945
	
#line 945
	#line 59 "msg.bi"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 59
drop_current_message);
#line 184 "msg.bi"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 192 "msg.bi"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 210 "msg.bi"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 226 "msg.bi"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 244 "msg.bi"
va_builtin_install_ex("message_body_is_empty", bi_message_body_is_empty, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 295 "msg.bi"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 314 "msg.bi"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 332 "msg.bi"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 348 "msg.bi"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 379 "msg.bi"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 392 "msg.bi"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 409 "msg.bi"
va_builtin_install_ex("message_nth_header_name", bi_message_nth_header_name, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 425 "msg.bi"
va_builtin_install_ex("message_nth_header_value", bi_message_nth_header_value, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 444 "msg.bi"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 459 "msg.bi"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 474 "msg.bi"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 497 "msg.bi"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 505 "msg.bi"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 532 "msg.bi"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 540 "msg.bi"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 567 "msg.bi"
va_builtin_install_ex("message_to_stream", bi_message_to_stream, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_number, dtype_string);
#line 624 "msg.bi"
va_builtin_install_ex("message_from_stream", bi_message_from_stream, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 676 "msg.bi"
va_builtin_install_ex("message_body_to_stream", bi_message_body_to_stream, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_number, dtype_string);

#line 945 "../../src/builtin/snarf.m4"
	
#line 945
	 mf_add_runtime_params(msg_cfg_param);
#line 945
	 
#line 945
}
#line 945 "../../src/builtin/snarf.m4"

